ents = {}
ents.objects = {}
ents.objpath = "entities/"
local register = {}
local id = 0

function ents.Startup()																		-- all entities must go here
	register["CharName"] = love.filesystem.load( ents.objpath .. "CharName.lua" )
end

function ents.Derive(name)
	return love.filesystem.load( ents.objpath .. name .. ".lua" )()
end

function ents.Create(name, x, y)															-- initialize an entity by it's name, at x & y coordinates
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end
	
	if register[name] then
		id = id + 1
		local ent = register[name]()
		ent:load()
		ent.name = name
		ent:setInfo(name, x, y)
		ent.id = id
		ents.objects[id] = ent
		return ents.objects[id]
	else
		print("error: entity " .. name .. " does not exist.")								-- reminder to register entity in ents.Startup
		return false;
	end
end

function ents:update(dt)																	-- update entities per frame
   	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end

function ents:draw()																		-- draw entities per frame
	for i, ent in pairs(ents.objects) do
		if ent.draw then
			ent:draw()
			test()
		end
	end
end

function test()
	for i, ent in pairs(ents.objects) do
		love.graphics.print("Hello " .. ent.name .. ", you are a " .. ent.class .. " object!", 0, 0)
	end
end