local ent = ents.Derive("base")

xVelocity = 0
yVelocity = 0
 
playerJumpVelocity = -500
runSpeed = 350

gravity = 1600

momentum = 0

tiptoe = .25 																	-- time before deceleration applies to movement

playerState = "jump"
canJump = "yes"

function ent:setInfo( name, x, y )
	name = "CharName"
	self.x = x
	self.y = y
	self.w = 40
	self.h = 40
end

function ent:load( name, x, y )
	self.class = "player"														-- differentiate between the kind of entity (player, projectile, enemy, etc)																				
	self:setInfo( name, x, y )													     
end
	
function ent:update(dt)
	self.x = self.x + (xVelocity * dt)                                          -- update the player's position
	self.y = self.y + (yVelocity * dt)

    if love.keyboard.isDown("d") and not(love.keyboard.isDown("a")) then        -- move left and right, prevent left+right situations
		momentum = love.timer.getTime() - moveStart
		xVelocity = runSpeed
	elseif love.keyboard.isDown("a") and not(love.keyboard.isDown("d"))then
		momentum = love.timer.getTime() - moveStart
		xVelocity = -runSpeed
	else
		if momentum >= tiptoe then												-- decelerate after moving, if momentum is great enough.  Otherwise, you can tip-toe
			xVelocity = xVelocity * (1 - math.min(dt*10, 1))
		else
			xVelocity = 0
		end
    end
	
    if not(playerState == "jump") and love.keyboard.isDown("j") then            -- if the j key is pressed make player jump
		if canJump == "yes" then												-- check if key is still down (main.lua ~ function love.keyreleased)
			yVelocity = playerJumpVelocity
			self.y = self.y - 1													-- force player into the air 1 pixel before setting jump state
			playerState = "jump"												-- character is in the air
			canJump = "no"														-- prevent character from jumping again until button is released (main.lua ~ function love.keyreleased)
		end
    end
    
	if playerState == "stand" and not(love.keyboard.isDown("j")) then			-- allow char to jump again
		canJump = "yes"
	end
	
    yVelocity = yVelocity + (gravity * dt)										-- apply gravity
	
    if self.y >= yFloor - self.h then											-- stop the player when they hit the ground
		self.y = yFloor - self.h
		yVelocity = 0
		playerState = "stand"
    end
end

function ent:draw()
	love.graphics.setColor( 0, 0, 0, 255 )
	love.graphics.rectangle( "fill", self.x, self.y, self.w, self.h )
end

return ent;